Uses TMTCD,CRT;
Var  T,T1,T2:TMSF;
     B:Boolean;
procedure ShowPercent(Position,Maximum:LongInt;X,Y,T,B,C:Byte);
var i, j: integer;
    full, rem: longint;
    s: string[7];
    mask: byte;
    DisplayString, Attribs, RepChar: array [0..15] of byte;
begin
    fillchar(DisplayString, 16, 32);
    fillchar(Attribs, 16, (B shl 4)+T);
    full := (position*128 div Maximum) shr 3;
    rem := (position*128 div Maximum) and 7;
    fillchar(DisplayString, full, #219);
    str(position*100 div Maximum, s);
    s := s+'%';
    j := 7 - length(s) shr 1;
    for i := 1 to length(s) do begin
        DisplayString[j+i] := ord(s[i]);
        if j+i < full then attribs[j+i] := (T shl 4)+B;
       end;
    mask := not ($FF shr rem);
    if rem <> 0 then begin
    inline($FA); PortW[$3C4]:=$0402;
    PortW[$3C4]:=$0704; PortW[$3CE]:=$0204;
    PortW[$3CE]:=$0005; PortW[$3CE]:=$0006;

    move(mem[$A000:DisplayString[full] shl 5], RepChar, 16);
    for i := 0 to 15 do
     RepChar[i] := RepChar[i] xor mask;
    move(RepChar,mem[$A000:C*32],16);

    PortW[$3C4]:=$0302; PortW[$3C4]:=$0304;
    PortW[$3CE]:=$0004; PortW[$3CE]:=$1005;
    PortW[$3CE]:=$0E06; inline($FB);
        DisplayString[full] := C;
    end;
    for i := 0 to 15 do begin
        mem[$B800:i*2+pred(x)*2+pred(y)*160] := DisplayString[i];
        mem[$B800:i*2+pred(x)*2+pred(y)*160+1] := attribs[i];
    end;
end;

begin
  asm mov ax,3; int 10h; mov ax,1003h; mov bl,0; int 10h;
      mov ah,01h; mov ch,20h; xor cl,cl; int 10h end;
  Writeln('Example program for TMTCD unit. Copyright (c) 1998 Andrew Luzhin.');
  Writeln('Press Esc to exit.');
  PlayTrack(1);
  repeat
   AllStat2(T1,T,T2,B);
   Write(T.Trk:2,' - ',T.Min:2,':',T.Sec:2);
   GetTrkRem(T);
   Write('  ',T.Min:2,':',T.Sec:2);
   Write(' - ',T2.Trk,'      ',#13);
   ShowPercent(HSG(T1),HSG(T2),1,4,15,1,0);
  until Port[$60]=1;
  asm mov ax,3; int 10h; end;
End.
